%define section   free
%define base_name commons-jci
%define jakarta_version 0.1
%define cvs_date  20051002

Name:           jakarta-%{base_name}
Version:        %{jakarta_version}
Release:        0.%{cvs_date}.2jpp
Epoch:          0
Summary:        Commons Java Compiler Interface
License:        Apache License 2.0
Url:            http://jakarta.apache.org/commons/sandbox/jci/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:	JPackage
SOURCE0:	%{base_name}-%{cvs_date}-src.tar.gz
# svn export http://svn.apache.org/repos/asf/jakarta/commons/sandbox/jci/trunk/

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        %{base_name}-%{version}-jpp-depmap.xml
Source5:        commons-build.tar.gz
Patch0:         commons-jci-0.1-EclipseJavaCompiler.patch
Patch1:         commons-jci-0.1-navigation_xml.patch
Patch2:         commons-jci-0.1-project_properties.patch

BuildRequires:  ant >= 0:1.6, jpackage-utils >= 0:1.6
BuildRequires:	junit, maven, saxon, saxon-scripts
BuildRequires:	antlr
BuildRequires:	cobertura
BuildRequires:	jline

BuildRequires:	asm
BuildRequires:	asm2
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-io
BuildRequires:	jakarta-commons-lang
BuildRequires:	jakarta-commons-logging
BuildRequires:	groovy-jsr
BuildRequires:	eclipse-ecj
BuildRequires:	janino
BuildRequires:	oro
BuildRequires:	log4j
BuildRequires:	gnu.getopt
BuildRequires:	ccl-util

Requires:	asm2
Requires:	jakarta-commons-collections
Requires:	jakarta-commons-io
Requires:	jakarta-commons-lang
Requires:	jakarta-commons-logging
Requires:	groovy-jsr
Requires:	eclipse-ecj
Requires:	janino
Requires:	oro
Requires:	log4j
Requires:	gnu.getopt
Requires:	ccl-util
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
JCI is a java compiler interface featuring a compiling classloader.
The current implementation supports compilation via the following 
compilers:
* eclipse
* janino
* groovy-jsr

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{base_name}-%{cvs_date}-src
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
gzip -dc %{SOURCE5} | tar xf -

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

export DEPCAT=$(pwd)/%{base_name}-%{version}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > %{base_name}-%{version}-depmap.new.xml


%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags \

mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
antlr \
asm/asm \
asm2/asm2 \
asm2/asm2-analysis \
asm2/asm2-attrs \
asm2/asm2-commons \
asm2/asm2-tree \
asm2/asm2-util \
commons-collections \
commons-io \
commons-lang \
commons-logging \
commons-logging-api \
groovy-jsr \
eclipse/org.eclipse.jdt.core/jdtcore \
junit \
janino \
cobertura \
oro \
log4j \
gnu.getopt \
ccl-util \


build-jar-repository .maven/repository/JPP/jars \
jline \


mkdir -p .maven/repository/JPP/plugins
build-jar-repository -s -p .maven/repository/JPP/plugins \
sf-maven-plugins/maven-cobertura-plugin


maven \
	-Dmaven.javadoc.source=1.4 \
	-Dmaven.home.local=$(pwd)/.maven \
	jar javadoc xdoc:transform


%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{base_name}-trunk.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in jakarta-*; do \
ln -sf ${jar} ${jar/jakarta-/}; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/docs/apidocs

## manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf target/docs/navigation.xml.sav
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -sf %{name}-%{version} %{_javadocdir}/%{name}
 
%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Oct 24 2005 Ralph Apel <r.apel@r-apel.de> 0:0.1-0.20051002.2jpp
- Fix typo in eclipse-ecj Requires:

* Wed Oct 19 2005 Ralph Apel <r.apel@r-apel.de> 0:0.1-0.20051002.1jpp
- First release
